Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/CONFIG/SHARED/field_def.xml
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 5602)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 6787)
@@ -29,4 +29,14 @@
          <field id="soce_e3t"     long_name="salinity * e3t"                                                        unit="1e-3*m"   grid_ref="grid_T_3D" > soce * e3t </field >
 
+         <field id="ocean_volume_crs_t"          long_name="ocean_volume_crs_t"                                       unit="m^3"  grid_ref="grid_T_3D"/>
+         <field id="rabt"          long_name="rabt"                                       unit="degC"  grid_ref="grid_T_3D"/>
+         <field id="rabs"          long_name="rabs"                                       unit="degC"  grid_ref="grid_T_3D"/>
+         <field id="rhd"          long_name="rhd"                                       unit="degC"  grid_ref="grid_T_3D"/>
+         <field id="rhd_crs"      long_name="rhd_crs"                                   unit="degC"  grid_ref="grid_T_3D"/>
+         <field id="rn2"         long_name="rn2"                                      unit="degC"  grid_ref="grid_T_3D"/>
+         <field id="rn2b"         long_name="rn2b"                                      unit="degC"  grid_ref="grid_T_3D"/>
+         <field id="rb2_crs"      long_name="rb2_crs"                                   unit="degC"  grid_ref="grid_T_3D"/>
+         <field id="rhop_crs"         long_name="potential density (sigma0)"                unit="kg/m3"  grid_ref="grid_T_3D"/>
+
          <field id="sst"          long_name="sea surface temperature"             standard_name="sea_surface_temperature"             unit="degC"     />
          <field id="sst2"         long_name="square of sea surface temperature"   standard_name="square_of_sea_surface_temperature"   unit="degC2"     > sst * sst </field >
@@ -75,4 +85,6 @@
          <field id="mldr0_3"      long_name="Mixed Layer Depth (dsigma = 0.03 wrt sfc)"      standard_name="ocean_mixed_layer_thickness_defined_by_sigma_theta"                                unit="m"                         />
          <field id="mld_dt02"     long_name="Mixed Layer Depth (|dT| = 0.2 wrt 10m)"         standard_name="ocean_mixed_layer_thickness_defined_by_temperature"                                unit="m"                         />
+         <field id="hmlpt"     long_name="hmlpt"         standard_name="hmlpt"                                unit="m"                         />
+         <field id="nmln"     long_name="nmln"         standard_name="hmlpt"                                unit="m"                         />
          <field id="topthdep"     long_name="Top of Thermocline Depth (dT = -0.2 wrt 10m)"   standard_name="ocean_mixed_layer_thickness_defined_by_temperature"                                unit="m"                         />
          <field id="pycndep"      long_name="Pycnocline Depth (dsigma[dT=-0.2] wrt 10m)"     standard_name="ocean_mixed_layer_thickness_defined_by_sigma_theta"                                unit="m"                         />
@@ -180,4 +192,5 @@
          <field id="precip"       long_name="Total precipitation"                  standard_name="precipitation_flux"                                                   unit="kg/m2/s"   />
  
+         <field id="kpar"         long_name="kpar"                                  standard_name="kpar"                                                                 unit="kg/m2/s"   />
          <field id="qt"           long_name="Net Downward Heat Flux"                standard_name="surface_downward_heat_flux_in_sea_water"                              unit="W/m2"                           />
          <field id="qns"          long_name="non solar Downward Heat Flux"                                                                                               unit="W/m2"                           />
@@ -374,4 +387,8 @@
          <field id="uocet"        long_name="ocean transport along i-axis times temperature (CRS)"                                               unit="degC*m/s"   grid_ref="grid_U_3D" />
          <field id="uoces"        long_name="ocean transport along i-axis times salinity (CRS)"                                                  unit="1e-3*m/s"   grid_ref="grid_U_3D" />
+         <field id="uslp_crs"     long_name="crs slope current along i-axis"              unit="m/s"  grid_ref="grid_U_3D" />
+         <field id="uslp"         long_name="slope current along i-axis"                  unit="m/s"  grid_ref="grid_U_3D" />
+         <field id="e2e3u_crs"    long_name="e2e3u_crs"                  unit="m/s"  grid_ref="grid_U_3D" />
+         <field id="e2e3u_msk"    long_name="e2e3u_msk"                  unit="m/s"  grid_ref="grid_U_3D" />
 
          <!-- variables available with MLE -->
@@ -409,4 +426,8 @@
          <field id="vocet"        long_name="ocean transport along j-axis times temperature (CRS)"                                               unit="degC*m/s"   grid_ref="grid_V_3D" />
          <field id="voces"        long_name="ocean transport along j-axis times salinity (CRS)"                                                  unit="1e-3*m/s"   grid_ref="grid_V_3D" />
+         <field id="vslp_crs"     long_name="crs slope current along j-axis"              unit="m/s"  grid_ref="grid_V_3D" />
+         <field id="vslp"         long_name="slope current along j-axis"                  unit="m/s"  grid_ref="grid_V_3D" />
+         <field id="e1e3v_crs"    long_name="e1e3v_crs"                  unit="m/s"  grid_ref="grid_V_3D" />
+         <field id="e1e3v_msk"    long_name="e1e3v_msk"                  unit="m/s"  grid_ref="grid_V_3D" />
 
          <!-- variables available with MLE -->
@@ -444,4 +465,14 @@
         <field id="avt"          long_name="vertical eddy diffusivity"   standard_name="ocean_vertical_heat_diffusivity"       unit="m2/s" />
         <field id="avm"          long_name="vertical eddy viscosity"     standard_name="ocean_vertical_momentum_diffusivity"   unit="m2/s" />
+
+        <field id="avte_crs1"          long_name="vertical eddy diffusivity"                unit="m2/s"   />
+        <field id="avte_crs2"          long_name="vertical eddy diffusivity"                unit="m2/s"   />
+        <field id="avte_crs3"          long_name="vertical eddy diffusivity"                unit="m2/s"   />
+        <field id="avte_crs4"          long_name="vertical eddy diffusivity"                unit="m2/s"   />
+        <field id="zt_crs"       long_name="zt_crs"                  unit="m2/s"   />
+        <field id="zs_crs"       long_name="zs_crs"                  unit="m2/s"   />
+        <field id="zmax_crs"       long_name="zmax_crs"                  unit="m2/s"   />
+        <field id="zerr_crs"       long_name="zerr_crs"                  unit="m2/s"   />
+        <field id="e1e2w_msk"       long_name="e1e2w_msk"                  unit="m2/s"   />
 
         <!-- avs: available with key_zdfddm -->
@@ -740,4 +771,6 @@
 
      <field_group id="ptrc_T" grid_ref="grid_T_3D">
+       <field id="Age"          long_name="Age tracer                       "        unit="year"    />
+       <field id="Age_e3t"      long_name="Age * e3t"                                unit="year*m"  > Age * e3t </field >
        <field id="DIC"          long_name="Dissolved inorganic Concentration"        unit="mmol/m3" />
        <field id="DIC_E3T"      long_name="DIC * E3T"                                unit="mmol/m2" > DIC * e3t </field >